import os,sys
from xml.dom.minidom import parse, parseString
import matplotlib.pyplot as plt
from SensorInterdia import sensor
from SensordataInterdia import sensordata
import matplotlib.dates as mdates
from datetime import datetime
import time

Archivocorrecto = True
# Hacemos la lista de objetos sensores
def DoListSensor(NumberSensor):
	for i in NumberSensor:
		ListSensor.add(sensor(i))
		
# Obtenemos el numero de sensores de los que recogemos datos
def ListNumberSensor(arg):
	Archivocorrecto = True
	EntryTree = parse(arg)
	listEntry = EntryTree.getElementsByTagName('entry')
	# Aqui obtenemos el arbol Dom, y comprobamos que esten todos los elementos del xml, para que se de por bueno.
	for i in listEntry:
		b = False
		try:
			Nodedate = i.getElementsByTagName('date')[0]
			Nodeclock = i.getElementsByTagName('clock')[0]
			Nodesensor = i.getElementsByTagName('sensor')[0] 
			Nodehumedity = i.getElementsByTagName('humedity')[0]
			Nodetemperature = i.getElementsByTagName('temperature')[0]
		except IndexError:
			b=True
		if(b == True):
			continue	
		Sensor = Nodesensor.childNodes[0].nodeValue
		NumberSensor.add(int(Sensor))


#Dibujamos los datos
def Draw(Datas):
	ListData = Datas.getListData()
	ArrayX = list()
	ArrayHUM = list()
	ArrayTEM = list()
	# Creamos la lista de los datos de humedad, de temperatura y de las fechas
	for i in ListData:
		ArrayX.append(i.getDate())
		ArrayHUM.append(i.getHum())
		ArrayTEM.append(i.getTemp())
	years = mdates.YearLocator()   # Por anyo, esto se crea para dar los limites de las graficas
	months = mdates.MonthLocator()  # Idem del anterior pero con meses
	days = mdates.DayLocator() 
	hours = mdates.HourLocator()
	minutes = mdates.MinuteLocator()
	Fmt = mdates.DateFormatter('%H:%M:%S')   # Creamos formato, para que se muestren las fechas asi en el eje X
	fig = plt.figure()
	ax = fig.add_subplot(111)
	ax.plot(ArrayX, ArrayHUM,'-o') # Dibujamos con eje X las fechas y eje Y las datos humedad
	lines = ax.plot(ArrayX, ArrayTEM,'-o') # Dibujamos en la misma grafica pero ahora el eje Y es temperatura y la dibujamos de color rojo
	plt.setp(lines, color='r', linewidth=2.0)
	if(len(ArrayX)!=1):
		# Buscamos el limite por debajo y el limite superior, para que la grafica no empiece por el primer dato obtenido si no por un dato del dia antes y el dia despues de lo obtenido.
		datemin = datetime(9999,12,1,1,1,1)
		datemax = datetime(1,1,1,1,1,1)
		# Colocamos el valor de  referencia de minimo y maximo en la grafica, en este caso es la hora y el minuto
		ax.xaxis.set_major_locator(hours)
		ax.xaxis.set_major_formatter(Fmt)
		ax.xaxis.set_minor_locator(minutes)
		for d in ArrayX:
			if(datemin.year>=d.year):
				if(datemin.month>=d.month):
					datemin = d
			if(datemax.year<=d.year):
				if(datemax.day<=d.day):
					datemax=d
		#datemin = datetime(datemin.year,datemin.month,datemin.day-1,datemin.hour,datemin.minute,datemin.second)
		#datemax = datetime(datemax.year,datemax.month,datemax.day+1,datemax.hour,datemax.minute,datemax.second)		
		#ax.set_xlim(datemin, datemax)
		
	# Formato de coordenadas de la grafica, pero la representacion no guardada
	def price(x): return '%1.2f'%x
	ax.format_xdata = mdates.DateFormatter('%H:%M:%S %Y/%m/%d')
	ax.format_ydata = price
	ax.grid(True)	
	# Creamos la leyenda que aparece en las graficas
	fig.autofmt_xdate()
	leg = ax.legend(('Humedity', 'Temperature'),
           'best', shadow=True)
	plt.savefig('grafic'+str(Datas.getNumberSensor())+'.png')	
	plt.clf()
		
def parser(arg):	

	EntryTree = parse(arg)
	listEntry = EntryTree.getElementsByTagName('entry')
	# Obtenemos el arbol Dom
	if(len(listEntry)!=0):
		for i in listEntry:
			b = False
			try:
				#Comprobamos que los datos obtenidos, estan completos.
				Nodedate = i.getElementsByTagName('date')[0]
				Nodeclock = i.getElementsByTagName('clock')[0]
				Nodesensor = i.getElementsByTagName('sensor')[0] 
				Nodehumedity = i.getElementsByTagName('humedity')[0]
				Nodetemperature = i.getElementsByTagName('temperature')[0]
			except IndexError:
				b = True
				#Si no pues volvemos ha iterar al siguiente nodo
			if(b == True):
				continue
			Date = Nodedate.childNodes[0].nodeValue
			Clock = Nodeclock.childNodes[0].nodeValue 
			Sensor = Nodesensor.childNodes[0].nodeValue
			Humedity = Nodehumedity.childNodes[0].nodeValue
			Temperature = Nodetemperature.childNodes[0].nodeValue
			# Obtenemos los valores de los nodos, y los guardamos en la lista de datos del objeto sensor correspondiente
			for i in ListSensor:
				# Iteramos en la lista de sensores, comprobamos que sea igual y si es el objeto sensor que queremos, creamos el objeto sensordata y lo introducimos en la lista de datos que tiene el objeto sensor 
				if(i.getNumberSensor()==int(Sensor)):
					SensorData = sensordata(Clock+' '+Date, Humedity, Temperature) 
					i.inputData(SensorData)
	else:
		print 'No hay datos para parsear'			
# Iteramos en los argumentos de entrada
if (len(sys.argv) == 1):
	print "Usage: " + sys.argv[0] + " fichero1.xml ... fichero2.xml"
	sys.exit
else:
	NumberSensor = set()
	ListSensor = set()
	for arg in range(1,len(sys.argv)):
		ListNumberSensor(sys.argv[arg])
	DoListSensor(NumberSensor)
	# Inicializamos las estructuras almacenamiento de datos que tenemos que usar para el parser
	for arg in range(1,len(sys.argv)):
		parser(sys.argv[arg])
	if(len(ListSensor)==0):
		sys.exit
	else:
		for i in ListSensor:
			Draw(i)

